package org.nuiton.topiatest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class QueriedEntityDAOAbstract<E extends QueriedEntity> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)QueriedEntity.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.QueriedEntity;
    }

    public E findByTestAdd(String v) throws TopiaException {
        E result = findByProperty(QueriedEntity.PROPERTY_TEST_ADD, v);
        return result;
    }

    public List<E> findAllByTestAdd(String v) throws TopiaException {
        List<E> result = findAllByProperty(QueriedEntity.PROPERTY_TEST_ADD, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //QueriedEntityDAOAbstract<E extends QueriedEntity>
